/*                                               */
/*                                               */
/*        Han-Gul Code Convert version 1.0       */
/*                                               */
/*        programed by Magic Book                */
/*                                               */
/*                                               */

#include "StdDef.h"
#include "HanConv.h"

byte HanCodeTable[]=
      "abehijkqstuvwxy{|}"
      "ňɈ"
      "AEIQSUVWabcehiqsuvw{"
      "ŉɉˉщӉՉ׉"
      "ABEIQSUWaeisu"
      "Պ"
      "AEIabehijqsuw"
      "abceikqsuvw{"
      ""
      "ABEQUWaeiuv{"
      "ɍ֍׍"
      "AEIQSWa"
      "ŎɎюӎ֎"
      "Aabegikpqsuw{"
      "abcehijkqsuvwxy{}"
      ""
      "ABEIQSUVWabeiqsvwz"
      "őɑ"
      "AEIQSUabeisuw"
      "ABIQSWabeijkqsuwx|"
      "abcehijklpqsuvwxy}"
      ""
      "ABEIQSUVWaeivw"
      "ŕɕ"
      "AEIQSUaז"
      "AEIQWabehikqsuw"
      "abeiqsuvw}"
      "ABEIQSUVWavə"
      "AE"
      "abehiqsu"
      "abeiqsuvwx|}"
      ""
      "ABEIQSUWabeiqsuvw"
      "ŝם"
      "AEIQSUWaeisuw"
      "ABEIQSUWabeiqsuwx{|"
      "abeghijkqsuwx{}"
      ""
      "ABEIQSUVWabeiuvwyš֡"
      "AEISUWaeisu"
      ""
      "AEIQUaeiqu"
      "abcdehijklqsuw{"
      ""
      "ABEHIQSUVWabeisuvw{"
      "ť֥"
      "ABEIQSae"
      "AEIQUWabeiqsu"
      "abeikqsuvw}"
      "AWabqsuvw"
      "Aaw"
      "AWaeiqs"
      "abdehijkqsuvw{"
      "ŬɬѬ׬"
      "ABEIQSUVWabeiqsuvw"
      "­ŭɭ׭"
      "AEIQSUabeiqsuw"
      "®ŮɮѮ׮"
      "ABIQUWabeijqsuw"
      "abdeiqsvw}"
      "AEIW±űֱ"
      "AEIQSa"
      "Wabeikpqs"
      "abefgijkpqsuvw{|"
      "ŴɴӴ"
      "ABEIQSUWabceiklqstuvw{|}"
      "µŵɵѵӵյֵ׵"
      "ABEIQSUWabeiqsuw"
      "¶ŶɶѶӶ׶"
      "ABEIQSUWYabeioqsuwxyz{|}"
      ""
      "abeghikqsuvwx"
      "Ÿɸ"
      "ABEIQSUWaeiqsvw"
      "¹ɹӹչ׹"
      "AEIQSUWabew"
      "AEIQabeiqsuw"
      "abegilqsuvw"
      "AWav½ɽֽ"
      "AEIQSw"
      "Aaquw"
      "abegiqsuvwx"
      ""
      "ABEIQSUWaev"
      "AEIQSUWaq¡¶"
      "AEIQWabeiqsuwáâåèéêñóõ÷"
      "abeiqsuwāĂąĉđēĕĖėġĢķ"
      "ABEIQSUWaeiqsuvwŁšŢťũűųŵŷ"
      "AIaƁƂƅƉƑƓƕƗơƥƩƷ"
      "AEIQabeiqswǡǢǥǩǱǳǵǷ"
      "abeijqsuvwȁȂȅȉȑȓȕȖȗȡȷ"
      "ABEIQSUWaevɁɅɡɢɥɩɱɳɵɷɼ"
      "AEUWaʁʂʅʉʑʓʕʗʡʶ"
      "AEIQWabehikqsuˁ˅ˉˑ˓ˡˢ˥˩˱˳˵˷"
      "abceikqsuvw{̡̢̖̗́̂̅̉̑̓̕"
      "ABEIQSUWaeiqsvẃ͉͓͕ͥͩ͢͡ͱͳ͵ͷ"
      "AEaeisu΁΂΅ΈΉ΋ΑΓΕΗΡη"
      "AEIQUWaeiqsuϡϢϥϩϱϳϵϷ"
      "abeinqsuwЁЂЅЉБГЕЖЗСз"
      "ABEIQSUWabeiqsuvwсхщѓ"
      "ѡѢѥѩѮѱѳѵѷѻ"
      "ABEISUWaeisuҁ҂҅҉Ҏґҕҗ"
      "ҡҥҩұҷ"
      "ABEIQUWabeghijqsuw{"
      "ӁӅӉӑӓӗӡӢӥөӱӳӵӷ";

byte  FixedGrfTable[]=
      "١ڢߢܡۡΡϢܢݢգҡס١С"
      "ҴϡߡŢƢǢȦ¦"
      "æĦŦƦȦǦ"
      "âɢʢˢ̥ᩬåҥե٥ĩաá¡"
      "ܡ";

void far ToFixedChar (byte far *pos)
{
      byte far *mid;
      word start,end,index;

      if  (*pos>=0xe0) {
        if (*(pos+1)>0xa0) {
           *pos=(*pos-0xe0)*2+0xcb;
        } else {
           if (*(pos+1)>0x90) *(pos+1)=*(pos+1)-0x12+0x70;
           else               *(pos+1)=*(pos+1)+0x70;
           *pos=(*pos-0xe0)*2+0xca;
        }
        return;
      }

      if  (*pos==0xD4) {
          *pos    =FixedGrfTable[(*(pos+1) & 0x7F)*2  ];
          *(pos+1)=FixedGrfTable[(*(pos+1) & 0x7F)*2+1];
          return;
      } else if (*pos>=0xd9 && *pos<=0xde) {
          if (*(pos+1)>0xa0) {
             *pos=(*pos-0xd9)*2+0xa2;
          } else {
             if (*(pos+1)>0x90) *(pos+1)=*(pos+1)-0x12+0x70;
             else               *(pos+1)=*(pos+1)+0x70;
             *pos=(*pos-0xd9)*2+0xa1;
          }
          return;
      }

      start=0;
      end  =(sizeof(HanCodeTable)-1)/2-1;
      while (start<=end) {
         index=(start+end)/2;
         mid=HanCodeTable+index*2;
         if (*pos>*mid) start=index+1;
         else if (*pos<*mid) end=index-1;
         else if (*(pos+1)>*(mid+1))  start=index+1;
         else if (*(pos+1)<*(mid+1))  end=index-1;
         else {
              *pos    =(index/94)+0xB0;
              *(pos+1)=(index%94)+0xA1;
              return;
         }
      }
      *pos    =FixedGrfTable[0];
      *(pos+1)=FixedGrfTable[1];
}

void far ToCombiChar (byte far *pos)
{
      word index;

      if (*pos>0xc9) {
         if (*pos%2==0) {
            if (*(pos+1)>0xee) *(pos+1)=*(pos+1)-0x70+0x12;
            else               *(pos+1)=*(pos+1)-0x70;
            *pos=(*pos-0xca)/2+0xe0;
         } else {
            *pos=(*pos-0xca)/2+0xe0;
         }
         return;
      }

      if (*pos<0xAD) {
         if (*pos%2!=0) {
            if (*(pos+1)>0xee) *(pos+1)=*(pos+1)-0x70+0x12;
            else               *(pos+1)=*(pos+1)-0x70;
            *pos=(*pos-0xa1)/2+0xd9;
         } else {
            *pos=(*pos-0xa1)/2+0xd9;
         }
         return;
      }

      index =(word)(*pos-0xB0)*94;
      index+=((word)*(pos+1)-0xA1);
      *pos    =HanCodeTable[index*2];
      *(pos+1)=HanCodeTable[index*2+1];
}

void far ToFixed(char *Data,word Len)
{
   word i;

   for (i=0 ; i<Len ; )
     if ((byte)Data[i]<128) i++;
     else  ToFixedChar(Data+i),i+=2;
}

void far ToCombi(char *Data,word Len)
{
   word i;

   for (i=0 ; i<Len ; )
     if ((byte)Data[i]<128) i++;
     else  ToCombiChar(Data+i),i+=2;
}

